/*
 * Copyright (C) 2015 Darron Broad
 * All rights reserved.
 * 
 * This file is part of Ape65.
 * 
 * Ape65 is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation. 
 * 
 * Ape65 is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. 
 * 
 * You should have received a copy of the GNU General Public License along
 * with Ape65. If not, see http://www.gnu.org/licenses/
 */

#ifndef _APE65_H
#define _APE65_H

#include <stdio.h>                                                                                                                                                        
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>

#define false (0)
#define true (1)

#define SLEN (256)
#define FF (0xFF)

#if defined(APE_POSIX)
 #include "posix.h"
#endif

#if defined(APE_MX150) || defined(APE_MX170) || defined(APE_MX250) || defined(APE_MX270)
 #include "pic32mx.h"
#endif

#if defined(APE_MX250_CKPI) || defined(APE_MX270_CKPI)
 #include "chipKITPi.h"
#endif

#if defined(APE_SDXL)
 #include "sdxl.h"
#endif

#include "util.h"
#include "6502.h"
#include "assembler.h"
#include "monitor.h"

#include "rom.h"

#endif
