/*
 * Copyright (C) 2015 Darron Broad
 * All rights reserved.
 * 
 * This file is part of Ape65.
 * 
 * Ape65 is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation. 
 * 
 * Ape65 is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. 
 * 
 * You should have received a copy of the GNU General Public License along
 * with Ape65. If not, see http://www.gnu.org/licenses/
 */

#include "ape65.h"

char runstop = '\0';

void
delay_ms(uint32_t ms)
{
	uint32_t startTime, waitTime;

	startTime = ReadCoreTimer();
	waitTime = (FCY / 2000) * ms;

	while ((ReadCoreTimer() - startTime) < waitTime)
		;
}

char
getcharacter(void)
{
	char c;

	if (U2STAbits.OERR) {
		U2STAbits.OERR = 0;
	}
	if (U2STAbits.URXDA) {
		c = U2RXREG;
		if (c >= 'A' && c <= 'Z')
		        c += 'a' - 'A';
		else if (c >= 'a' && c <= 'z')
		        c -= 'a' - 'A';
		else if (c == 127)
			c = 8;
		runstop = c;

		return (c);
	}

	return (0);
}

void
putcharacter(char c)
{
	while (U2STAbits.UTXBF) {
		if (U2STAbits.OERR) {
			U2STAbits.OERR = 0;
		}	
	}
	U2TXREG = c;
}

void
_mon_putc(char c)
{
	putcharacter(c);
}

void
init_uart2(void)
{
	U2BRG = UBAUD(115200);
	U2STA = 0;
	U2MODE = 0;
	U2MODE = (1 << _U2MODE_ON_POSITION) | (1 << _U2MODE_BRGH_POSITION);
	U2STA = (1 << _U2STA_URXEN_POSITION) | (1 << _U2STA_UTXEN_POSITION);
}
