/*
 * Copyright (C) 2015 Darron Broad
 * All rights reserved.
 * 
 * This file is part of Ape65.
 * 
 * Ape65 is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation. 
 * 
 * Ape65 is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. 
 * 
 * You should have received a copy of the GNU General Public License along
 * with Ape65. If not, see http://www.gnu.org/licenses/
 */

#ifndef _PIC32MX_H
#define _PIC32MX_H

#include <plib.h>

#if defined(APE_MX150)
#define FCY (40000000UL)
#define RAM_SIZE (0x4000) /* 16KB */
#endif

#if defined(APE_MX170)
#define FCY (48000000UL)
#define RAM_SIZE (0xC000) /* 48KB */
#endif

#if defined(APE_MX250)
#define FCY (40000000UL)
#define RAM_SIZE (0x4000) /* 16KB */
#endif

#if defined(APE_MX270)
#define FCY (48000000UL)
#define RAM_SIZE (0xC000) /* 48KB */
#endif

#if defined(APE_MX795)
#define FCY (80000000UL)
#define RAM_SIZE (0xC000) /* 48KB */
#endif

#include "pic32.h"

uint8_t peek(uint16_t);
void poke(uint16_t, uint8_t);

#endif /* !_PIC32MX_ */
