/*
 * Copyright (C) 2015 Darron Broad
 * All rights reserved.
 * 
 * This file is part of Ape65.
 * 
 * Ape65 is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation. 
 * 
 * Ape65 is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. 
 * 
 * You should have received a copy of the GNU General Public License along
 * with Ape65. If not, see http://www.gnu.org/licenses/
 */

#include "6502.h"

extern struct register_file reg;

void
ADC(uint8_t op1, uint8_t op2)
{
	uint16_t acc;

	acc = op1 + op2 + (reg.SR & 1);
	zero_negative(acc);
	overflow(acc, op1, op2);
	if (reg.SR & DECIMAL) {
		acc = (op1 & 0x0F) + (op2 & 0x0F) + (reg.SR & CARRY);
		if (acc > 0x09)
			acc += 0x06;
		reg.AC = acc & 0x0F;
		acc = (op1 & 0xF0) + (op2 & 0xF0) + (acc & HALFCARRY);
		if (acc > 0x90)
			acc += 0x60;
		reg.AC |= acc & 0xF0;
	} else {
		reg.AC = acc;
	}
	carry((acc & CARRYOUT) != 0);
}
