#include "6502.h"

extern struct register_file reg;

/*
 * Update carry flag
 */
void
carry(uint8_t val)
{
	if (val)
		reg.SR |= CARRY;
	else
		reg.SR &= ~CARRY;
}

/*
 * Update zero and negative flags
 */
void
zero_negative(uint8_t val)
{
	/* Set/Reset zero flag */
	if (val)
		reg.SR &= ~ZERO;
	else
		reg.SR |= ZERO;

	/* Set/Reset sign flag */
	if (val & NEGATIVE)
		reg.SR |= NEGATIVE;
	else
		reg.SR &= ~NEGATIVE;
}

/*
 * Update overflow flag (after ADC or SBC)
 */
void
overflow(uint8_t val1, uint8_t val2, uint8_t val3)
{
	if (0x80 & (val1 ^ val2) & (val1 ^ val3))
		reg.SR |= OVERFLOW;
	else
		reg.SR &= ~OVERFLOW;
}
